#include < amxmodx >
#include < amxmisc >
#include < fakemeta >
#include < hamsandwich >
#include < engine >
#include < rog >

#define MAX_PLAYERS 32
#define MAX_ORIGINS 100
#define MAX_HEALTH 100.0

#define IsValidType(%1) (ItemType_MedKit <= %1 <= ItemType_Drink)

#define set_bit(%1,%2)	(%1 |= (1<<%2))
#define get_bit(%1,%2)	(%1 & (1<<%2))
#define clr_bit(%1,%2)	(%1 &= ~(1<<%2))

enum ( += 12345 )
{
	TASK_MEDKIT,
	TASK_DRINK,
	TASK_ENDED_MEDKIT,
	TASK_ENDED_DRINK
}

enum
{
	ItemType_MedKit,
	ItemType_Drink,
	
	ItemType_ItemCount
};

new const g_szTypes[ ][ ] =
{
	"ItemType_MedKit",
	"ItemType_Drink"
}

new const g_iTypes[ ] =
{
	ItemType_MedKit,
	ItemType_Drink
}

new const g_szItemNames[ ItemType_ItemCount ][ ] =
{
	"item_medkit",
	"item_drink"
};

new const g_szItemModels[ ItemType_ItemCount ][ ] =
{
	"models/w_medkit.mdl", 
	"models/can.mdl"
};

new g_iPlayerItems[ MAX_PLAYERS + 1 ][ ItemType_ItemCount ];

new const g_szCustomEntitiesFile[ ] = "GameEntities.ini";
new const g_szItemClass[ ] = "item_heal";

new g_iMaxPlayers;
new g_iMsgBarTime;

new g_iMedKit;
new g_iDrink;

new g_iCvars[ 4 ];

new Trie:g_tType;
new Array:g_aEntities;

const MAX_ITEMS_CARRIED = 3;

public plugin_init( )
{
	register_plugin( "CS Battle Royale BackPack", "1.1", "DoNii" );
	
	register_dictionary( "cs_battleroyale.txt" );

	ROGInitialize( 500.0, "CheckOrigin" );
	ROGDumpOriginData( );
	
	g_iMsgBarTime = get_user_msgid( "BarTime" );
	
	g_iCvars[ 0 ] = register_cvar( "csbr_medkit_consume_time", "10" );
	g_iCvars[ 1 ] = register_cvar( "csbr_drink_consume_time", "3" );
	g_iCvars[ 2 ] = register_cvar( "csbr_medkit_heal", "100" );
	g_iCvars[ 3 ] = register_cvar( "csbr_drink_heal", "25" );
	
	register_logevent( "OnRoundEnd", 2, "1=Round_End" );
	
	register_clcmd( "say /backpack", "@BackPack");
	
	register_touch( "player", g_szItemClass, "@Touch" );
	
	RegisterHam( Ham_Spawn, "player", "@HamSpawn_Post", 1 );
	
	register_forward( FM_CmdStart, "@CmdStart" );
	
	g_iMaxPlayers = get_maxplayers( );
}

public plugin_precache( )
{
	g_tType = TrieCreate( );
	g_aEntities = ArrayCreate( 1 );
	
	new i;
	for( i=0; i < sizeof g_szTypes; i++ )
	{
		TrieSetCell( g_tType, g_szTypes[ i ], g_iTypes[ i ] );
	}
	
	ReadCustomEntities( );
	
	for( i=0; i < ItemType_ItemCount; i++ )
	{
		precache_model( g_szItemModels[ i ] );
	}
}

public OnRoundEnd( )
{
	remove_entity_name( g_szItemClass );
}

public CheckOrigin( Float:fOrigin[ 3 ] )
{
	if( fOrigin[ 2 ] < -425.0 )
	{
		return 0;
	}
	return 1;
}

public client_disconnect( id )
{
	ClearBackPack( id );
	ClearBits( id );
}

public client_connect( id )
{
	ClearBackPack( id );
	ClearBits( id );
}

public @HamSpawn_Post( id )
{
	ClearBackPack( id );
}

public RoundStarted( )
{
	ROGShuffleOrigins( );

	new iType;
	for( new i; i < ArraySize( g_aEntities ); i++ )
	{
		iType = ArrayGetCell( g_aEntities, i );
		
		CreateCustomEntity( iType );
	}
}

@CmdStart( id, iHandle )
{
	if( ! is_user_alive( id ) )
	return FMRES_IGNORED;

	if( ! get_bit( g_iMedKit, id ) && ! get_bit( g_iDrink, id ) )
	return FMRES_IGNORED;
	
	new iButton = entity_get_int( id, EV_INT_button );
	
	if( iButton & IN_USE )
	{
		entity_set_int( id, EV_INT_button, entity_get_int( id, EV_INT_button ) & ~IN_USE );
		
		new iTimeMedKit = get_pcvar_num( g_iCvars[ 0 ] );
		new iTimeDrink = get_pcvar_num( g_iCvars[ 1 ] );
		
		if( get_bit( g_iMedKit, id ) )
		{						
			UTIL_BarTime( id, iTimeMedKit );
			set_task( float( iTimeMedKit ), "OnEndTakeMedKit", id + TASK_ENDED_MEDKIT );
			set_task( 1.0, "OnConsumingMedKit", id + TASK_MEDKIT, .flags="b" );
		}
		
		else if( get_bit( g_iDrink, id ) )
		{
			UTIL_BarTime( id, iTimeDrink );
			set_task( float( iTimeDrink ), "OnEndTakeDrink", id + TASK_ENDED_DRINK );
			set_task( 1.0, "OnConsumingDrink", id + TASK_DRINK, .flags="b" );
		}
	}
	return FMRES_IGNORED;
}

public OnConsumingMedKit( id )
{
	id -= TASK_MEDKIT;

	new Float:fVelocity[ 3 ];
	pev( id, pev_velocity, fVelocity );
	
	if( fVelocity[ 0 ] != 0.0 || fVelocity[ 1 ] != 0.0 || fVelocity[ 2 ] != 0.0 )
	{
		UTIL_BarTime( id, 0 );
		clr_bit( g_iMedKit, id );
		
		remove_task( id + TASK_ENDED_MEDKIT );
		remove_task( id + TASK_MEDKIT );
	}
	return PLUGIN_CONTINUE;
}

public OnEndTakeMedKit( id )
{
	id -= TASK_ENDED_MEDKIT;

	if( get_bit( g_iMedKit, id ) )
	{
		set_pev( id, pev_health, get_pcvar_float( g_iCvars[ 2 ] ) );
		client_print( id, print_chat, "%L", id, "TAKE_ITEM_MEDKIT", floatround( get_pcvar_float( g_iCvars[ 2 ] ) ) );
		
		g_iPlayerItems[ id ][ ItemType_MedKit ]--
		clr_bit( g_iMedKit, id );
	}
}

public OnConsumingDrink( id )
{
	id -= TASK_DRINK;

	new Float:fVelocity[ 3 ];
	pev( id, pev_velocity, fVelocity );
	
	if( fVelocity[ 0 ] != 0.0 || fVelocity[ 1 ] != 0.0 || fVelocity[ 2 ] != 0.0 )
	{
		UTIL_BarTime( id, 0 );
		clr_bit( g_iDrink, id );
		
		remove_task( id + TASK_ENDED_DRINK );
		remove_task( id + TASK_DRINK );
	}
	return PLUGIN_CONTINUE;
}

public OnEndTakeDrink( id )
{
	id -= TASK_ENDED_DRINK;

	if( get_bit( g_iDrink, id ) )
	{
		set_pev( id, pev_health, pev( id, pev_health ) + get_pcvar_float( g_iCvars[ 3 ] ) );
		client_print( id, print_chat, "%L", id, "TAKE_ITEM_DRINK", floatround( get_pcvar_float( g_iCvars[ 3 ] ) ) );
		
		g_iPlayerItems[ id ][ ItemType_Drink ]--
		clr_bit( g_iDrink, id );
	}
}

@Touch( id, iItem )
{
	new const iItemType = pev( iItem, pev_iuser1 );
	
	if( AddItemToPlayer( id, iItemType ) )
	{
		set_pev( iItem, pev_flags, pev( iItem, pev_flags ) | FL_KILLME ); 
		
		client_print( id, print_chat, "%L", id, "ADDED_ITEM_BACKPACK", g_szItemNames[ iItemType ] );
	}
	
	return PLUGIN_CONTINUE;
}

@RemoveItems( id )
{
	new iEntId = g_iMaxPlayers;
	while( ( iEntId = engfunc( EngFunc_FindEntityByString, iEntId, "classname", g_szItemClass ) ) > 0 )
	{
		set_pev( iEntId, pev_flags, pev( iEntId, pev_flags ) | FL_KILLME );
	}
}

@BackPack( id )
{
	new iMenu = menu_create( "Your Inventory:", "@BackPack_Handler" );
	
	new szBuffer[ 64 ], szItemId[ 2 ], iItemCount;
	for( new iType; iType < sizeof g_iPlayerItems[ ]; iType++ )
	{
		iItemCount = g_iPlayerItems[ id ][ iType ];
		if( iItemCount == 0 ) continue;
		
		num_to_str( iType, szItemId, charsmax( szItemId ) );
		formatex( szBuffer, charsmax( szBuffer ), "%s \rx%d", g_szItemNames[ iType ], iItemCount );
		menu_additem( iMenu, szBuffer, szItemId );
	}
	
	menu_display( id, iMenu, 0 );
}

@BackPack_Handler( id, iMenu, iItem )
{
	new iAccess, szItemType[ 2 ], iCallback;
	menu_item_getinfo( iMenu, iItem, iAccess, szItemType, charsmax( szItemType ), _, _, iCallback );
	menu_destroy( iMenu );
	
	new iItemType = str_to_num( szItemType );
	
	if( ! IsValidType( iItemType ) )
	return PLUGIN_HANDLED;
	
	if( ! ( 0 <= iItem <= 1 ) ) // prevent glitch when item is MENU_EXIT
	return PLUGIN_HANDLED;
	
	new iPlayerHealth = pev( id, pev_health );
	
	if( iItemType == ItemType_MedKit )
	{
		if( iPlayerHealth >= MAX_HEALTH )
		{
			client_print( id, print_chat, "%L", id, "CANT_TAKE_MEDKIT", floatround( MAX_HEALTH ) );
			return PLUGIN_HANDLED;
		}
		
		else
		{
			set_bit( g_iMedKit, id );
			clr_bit( g_iDrink, id );
			
			entity_set_int( id, EV_INT_button, entity_get_int( id, EV_INT_button ) | IN_USE );
		}
	}
	
	else if( iItemType == ItemType_Drink )
	{
		if( iPlayerHealth > MAX_HEALTH - get_pcvar_float( g_iCvars[ 3 ] ) )
		{
			client_print( id, print_chat, "%L", id, "CANT_TAKE_DRINK", floatround( MAX_HEALTH - get_pcvar_float( g_iCvars[ 3 ] ) ) );
			return PLUGIN_HANDLED;
		}
		
		else
		{
			set_bit( g_iDrink, id );
			clr_bit( g_iMedKit, id );
			
			entity_set_int( id, EV_INT_button, entity_get_int( id, EV_INT_button ) | IN_USE );
		}
	}
	
	return PLUGIN_HANDLED;
}

AddItemToPlayer( id, iItemType )
{
	if( g_iPlayerItems[ id ][ iItemType ] >= MAX_ITEMS_CARRIED ) return false;
	
	g_iPlayerItems[ id ][ iItemType ]++;
	return true;
}

ClearBackPack( id )
{
	for( new i; i < sizeof g_iPlayerItems[ ]; i++ )
	{
		g_iPlayerItems[ id ][ i ] = 0;
	}
}

ReadCustomEntities( )
{
	new szConfigsName[ 256 ], szFilename[ 512 ];
	get_configsdir( szConfigsName, charsmax( szConfigsName ) );
	
	formatex( szFilename, charsmax( szFilename ), "%s/%s", szConfigsName, g_szCustomEntitiesFile );
	
	new iFile = fopen( szFilename, "r" );
	
	if( iFile )
	{
		new szData[ 128 ];
		
		while( ! feof( iFile ) )
		{
			fgets( iFile, szData, charsmax( szData ) );
			trim( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';': 
				continue;
				
			default:
				{
					new szEntityType[ 32 ]
					
					if( parse( szData, szEntityType, charsmax( szEntityType ) ) != 1 )
					continue;
					
					new iType;
					if( TrieGetCell( g_tType, szEntityType, iType ) )
					{
						ArrayPushCell( g_aEntities, iType );
					}
				}
			}
		}
	}
	fclose( iFile );
}

ClearBits( id )
{
	clr_bit( g_iMedKit, id );
	clr_bit( g_iDrink, id );
}

CreateCustomEntity( const iType )
{
	new Float:fOrigin[ 3 ];
	ROGGetOrigin( fOrigin );

	new iEntity = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );
	
	set_pev( iEntity, pev_classname, g_szItemClass );
	engfunc( EngFunc_SetModel, iEntity, g_szItemModels[ iType ] );
	dllfunc( DLLFunc_Spawn, iEntity );
	engfunc( EngFunc_SetSize, iEntity, Float:{ -3.0, -3.0, -3.0 }, Float:{ 3.0, 3.0, 3.0 } );
	
	engfunc( EngFunc_SetOrigin, iEntity, fOrigin );
	
	set_pev( iEntity, pev_solid, SOLID_BBOX );
	set_pev( iEntity, pev_movetype, MOVETYPE_NONE );
	
	engfunc( EngFunc_DropToFloor, iEntity );
	
	set_pev( iEntity, pev_iuser1, iType );
}

UTIL_BarTime( id, iTime )
{
	message_begin( MSG_ONE, g_iMsgBarTime, _, id );
	write_short( iTime );
	message_end( );
}