#include < amxmodx >
#include < amxmisc >
#include < cstrike >
#include < hamsandwich >
#include < fakemeta >
#include < fun >

#define XO_CWEAPONBOX 4 

#if AMXX_VERSION_NUM >= 182
#define CSW_GLOCK 2
#endif

enum _:ModelType
{
	vModel[ 128 ],
	pModel[ 128 ],
	wModel[ 128 ]
}

new Trie:g_tWeaponModels;

new const g_szFileIni[ ] = "GameWeaponModels.ini";

new g_iSkip = ( 1 << CSW_GLOCK ) | ( 1 << CSW_C4 ) | ( 1 << CSW_VEST ) | ( 1 << CSW_VESTHELM )

stock const m_rgpPlayerItems_CWeaponBox[ 6 ] = { 34 , 35 , ... };

public plugin_init( )
{
	register_plugin( "CS Battle Royale Models", "1.0", "DoNii" );

	new szWeaponName[ 32 ];
	for( new i = CSW_P228; i <= CSW_P90; i++ )
	{
		if( g_iSkip & ( 1 << i ) )
		continue;
		
		get_weaponname( i, szWeaponName, charsmax( szWeaponName ) );
		RegisterHam( Ham_Item_Deploy, szWeaponName, "fw_HamItemDeployPost", 1 );
	}
}	

public plugin_precache( )
{
	g_tWeaponModels = TrieCreate( );
	ReadFile( );
	
	register_forward( FM_SetModel, "fw_FMSetModelPre", 0 );
}

public plugin_end( )
TrieDestroy( g_tWeaponModels );

public fw_FMSetModelPre( iEnt, szModel[ ] )
{
	if( ! pev_valid( iEnt ) )
	return FMRES_IGNORED;
	
	new szClassName[ 32 ], iData[ ModelType ];
	pev( iEnt, pev_classname, szClassName, charsmax( szClassName ) );
	
	if( equal( szClassName, "weaponbox" ) )
	{		
		if( ! equal( szModel, "models/w_weaponbox.mdl" ) )
		{
			new iWeaponID = GetWeaponBoxWeaponType( iEnt );
			
			new szWeaponName[ 32 ];
			GetWeaponName( iWeaponID, szWeaponName, charsmax( szWeaponName ) );
			
			replace( szWeaponName, charsmax( szWeaponName ), "weapon_", "" );
			trim( szWeaponName );
			
			if( TrieGetArray( g_tWeaponModels, szWeaponName, iData, sizeof iData ) )
			{
				if( iData[ wModel ][ 0 ] )
				{
					engfunc( EngFunc_SetModel, iEnt, iData[ wModel ] );
					return FMRES_SUPERCEDE;
				}
			}
		}
	}
	return FMRES_IGNORED;
}

public fw_HamItemDeployPost( iEnt )
{
	if( pev_valid( iEnt ) != 2 )
	return HAM_IGNORED;
	
	new id = get_pdata_cbase( iEnt, 41, 4 );
	
	if( ! is_user_connected( id ) )
	return HAM_IGNORED;
	
	new szClassName[ 32 ], iData[ ModelType ];
	pev( iEnt, pev_classname, szClassName, charsmax( szClassName ) );
	
	replace( szClassName, charsmax( szClassName ), "weapon_", "" );
	trim( szClassName );
	
	if( TrieGetArray( g_tWeaponModels, szClassName, iData, sizeof iData ) )
	{
		if( iData[ vModel ][ 0 ] )
		set_pev( id, pev_viewmodel2, iData[ vModel ] );
		
		if( iData[ pModel ][ 1 ] )
		set_pev( id, pev_weaponmodel2, iData[ pModel ] );
	}
	return HAM_IGNORED;
}

ReadFile( )
{
	new szConfigFilePath[ 256 ];
	get_configsdir( szConfigFilePath, charsmax( szConfigFilePath ) );
	format( szConfigFilePath, charsmax( szConfigFilePath ), "%s/%s", szConfigFilePath, g_szFileIni );
	
	new iFilePointer = fopen( szConfigFilePath, "rt" );
	if( iFilePointer )
	{
		new iLineData[ 160 ], szTrieKey[ 32 ], szTrieValue[ 128 ], szModelsForWeapon[ ModelType ], iCounter;
		
		while( ! feof( iFilePointer ) )
		{
			fgets( iFilePointer, iLineData, charsmax( iLineData ) );
			trim( iLineData );
			
			if( iLineData[ 0 ] == '/' || iLineData[ 0 ] == EOS )
			{
				continue;
			}

			strtok( iLineData, szTrieKey, charsmax ( szTrieKey ), szTrieValue, charsmax( szTrieValue ), '=' );
			trim( szTrieKey );
			trim( szTrieValue );
			
			switch( iCounter )
			{
			case 0:
				{
					copy( szModelsForWeapon[ vModel ], charsmax( szModelsForWeapon[ vModel ] ), szTrieValue );
					iCounter = iCounter + 1;
					
					if( szTrieValue[ 0 ] )
					precache_model( szTrieValue );
				}
			case 1:
				{
					copy( szModelsForWeapon[ pModel ], charsmax(szModelsForWeapon[ pModel ] ), szTrieValue )
					iCounter = iCounter + 1;
					
					if( szTrieValue[ 0 ] )
					precache_model( szTrieValue );
				}
			case 2:
				{
					copy( szModelsForWeapon[ wModel ], charsmax( szModelsForWeapon[ wModel ] ), szTrieValue );
					
					strtolower( szTrieKey[ 2 ] );
					TrieSetArray( g_tWeaponModels, szTrieKey[ 2 ], szModelsForWeapon, sizeof szModelsForWeapon );
					
					iCounter = 0;
					
					if( szTrieValue[ 0 ] )
					precache_model( szTrieValue );
				}
			}
		}
		fclose( iFilePointer );
	}
}

GetWeaponName( iWeapon, szWeaponName[ ], iLen )
{
	if( iWeapon == CSW_VEST )
	copy( szWeaponName, iLen, "weapon_kevlar" );

	else if( iWeapon == CSW_VESTHELM )
	copy( szWeaponName, iLen, "weapon_assault" );

	else
	get_weaponname( iWeapon, szWeaponName, iLen );
	
	return 0;
}

GetWeaponBoxWeaponType( iEnt ) 
{ 
	new iWeapon; 
	for( new i = 1; i <= 5; i++ ) 
	{ 
		iWeapon = get_pdata_cbase( iEnt, m_rgpPlayerItems_CWeaponBox[ i ], XO_CWEAPONBOX ); 
		if( iWeapon > 0 ) 
		{ 
			return cs_get_weapon_id( iWeapon ); 
		} 
	}
	return 0; 
} 