#include < amxmodx >
#include < fakemeta >
#include < engine >
#include < xs >
#include < fun >

enum ( += 9521 )
{
	TASK_CHECK_PLAYERS,
	TASK_RENEW_SPHERE,
	TASK_TIGHTEN_ZONE
}

new const g_szSprite[ ] = "sprites/laserbeam.spr";

new g_iSprite;

new g_iCvars[ 3 ];

new Float:g_fOrigin_Center[ 3 ] = { -8.5, -0.0, -485.4 }
new Float:g_fRadius;

public plugin_init( )
{
	g_iCvars[ 0 ] = register_cvar( "csbr_redzone_start_time", "60.0" );
	g_iCvars[ 1 ] = register_cvar( "csbr_redzone_tighten_freq", "120.0" );
	g_iCvars[ 2 ] = register_cvar( "csbr_redzone_radius", "2000.0" );
	
	register_logevent( "OnNewRound", 2, "1=Round_Start" );
	register_logevent( "OnRoundEnd", 2, "1=Round_End" );
}

public plugin_precache( ) 
{ 
	g_iSprite = precache_model( g_szSprite ); 
} 

public OnNewRound( )
{
	remove_task( TASK_CHECK_PLAYERS );
	remove_task( TASK_RENEW_SPHERE );
	remove_task( TASK_TIGHTEN_ZONE );
	
	g_fRadius = get_pcvar_float( g_iCvars[ 2 ] );
}

public OnRoundEnd( )
{
	remove_task( TASK_CHECK_PLAYERS );
	remove_task( TASK_RENEW_SPHERE );
	remove_task( TASK_TIGHTEN_ZONE );
}

public RoundStarted( )
{
	set_task( get_pcvar_float( g_iCvars[ 0 ] ), "OnActivateRedZone" );
	
	client_print( 0, print_center, "%L", LANG_PLAYER, "ZONE_APPEARS", floatround( get_pcvar_float( g_iCvars[ 0 ] ) ) );
}

public OnActivateRedZone( )
{
	set_task( 0.5, "KeepRenewingSphere", TASK_RENEW_SPHERE, .flags="b" ); // keep renewing the zone (0.1 will overflow)
	set_task( 2.0, "CheckPlayerOutsideArea", TASK_CHECK_PLAYERS, .flags="b" ); // check for outside the zone players
	set_task( get_pcvar_float( g_iCvars[ 1 ] ), "OnStartTighteningZone", TASK_TIGHTEN_ZONE, .flags="b" ); // start to tighten the zone (make it smaller)
}

public OnStartTighteningZone( )
{
	g_fRadius /= 2.0; // start reducing the radius
	
	client_print( 0, print_center, "%L", LANG_PLAYER, "ZONE_TIGHTEN" );
}

public KeepRenewingSphere( )
{
	const iDivides = 128; // cant go more than that
	new Float:fOrigin[ 3 ], Float:fAngle[ 3 ], Float:AngleMulScalar = ( 360.0 / iDivides ), Float:fVector[ 3 ];
	
	for( new i; i < iDivides; i++ )
	{
		angle_vector( fAngle, ANGLEVECTOR_RIGHT, fVector );
		xs_vec_mul_scalar( fVector, g_fRadius, fVector );
		xs_vec_add( g_fOrigin_Center, fVector, fOrigin );
		
		CreateBeam( fOrigin );
		
		fAngle[ 1 ] += AngleMulScalar;
	}
}

public CheckPlayerOutsideArea( )
{
	new Float:fPlayerOrigin[ 3 ];

	new iEnt = -1;
	while( ( iEnt = find_ent_by_class( iEnt, "player" ) ) != 0 )
	{
		pev( iEnt, pev_origin, fPlayerOrigin );
		
		fPlayerOrigin[ 0 ] -= g_fOrigin_Center[ 0 ];
		fPlayerOrigin[ 1 ] -= g_fOrigin_Center[ 1 ];

		if( Length2D( fPlayerOrigin ) > g_fRadius )
		{
			set_user_health( iEnt, get_user_health( iEnt ) - random_num( 1, 10 ) ); // using this instead of pev_health because this deals with Kill when Hp is 0
		}
	}
}

Float:Length2D( Float:Origin[ 3 ] )
{
	return floatsqroot( Origin[ 0 ] * Origin[ 0 ] + Origin[ 1 ] * Origin[ 1 ] );
}

CreateBeam( Float:fOrigin[ 3 ] )
{  
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_BEAMPOINTS )
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] )
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] )
	engfunc( EngFunc_WriteCoord, 4000.0 )
	write_short( g_iSprite ) 
	write_byte( 1 ) 
	write_byte( 5 ) 
	write_byte( 10 ) 
	write_byte( 50 ) 
	write_byte( 0 ) 
	write_byte( 255 )
	write_byte( 0 )
	write_byte( 0 )
	write_byte( 128 )
	write_byte( 1 )
	message_end( );
}