#include < amxmodx >
#include < cstrike >
#include < hamsandwich >
#include < fakemeta >
#include < engine >
#include < orpheu >
#include < orpheu_stocks >
#include < cs_battleroyale_faketeams >


#define MAX_PLAYERS 32

#if AMXX_VERSION_NUM >= 182
#define CSW_GLOCK 2
#endif

enum _:Tasks ( += 1000 )
{
	TASK_1 = 1000,
	TASK_2
};

enum _:PlayerStats
{
	Player_Kills,
	Player_HeadShots,
Float:Player_Damage,

	Player_StatsCount
};

new g_iSyncHudObject;
new g_iTime;
new g_iRestartRound;
new g_iFwRoundStart;
new g_iDummyResult;
new g_pGameRules;

new g_iCvars[ 2 ];

new g_iPlayerStats[ MAX_PLAYERS + 1 ][ Player_StatsCount ];

new bool:g_bHasGameStarted;
new bool:IsInRightOrder;
new bool:g_bVictoryBlockAttack[ 33 ];

const m_LastHitGroup = 75;

new OrpheuHook:HandleFindEntityByClassNameHook;

public plugin_init( )
{
	register_plugin( "CS Battle Royale Round Manager", "1.0", "DoNii" );
	
	g_iFwRoundStart = CreateMultiForward( "RoundStarted", ET_IGNORE );
	
	g_iSyncHudObject = CreateHudSyncObj( );
	
	g_iRestartRound = get_cvar_pointer( "sv_restartround" );
	
	OrpheuRegisterHookFromObject( g_pGameRules, "FPlayerCanRespawn", "CGameRules","OnFPlayerCanRespawn" );  
	OrpheuRegisterHookFromObject( g_pGameRules, "RestartRound", "CGameRules","CHalfLifeMultiplay_RestartRound", OrpheuHookPre );  
	
	g_iCvars[ 0 ] = register_cvar( "csbr_round_timer", "15" );
	g_iCvars[ 1 ] = register_cvar( "csbr_min_players", "2" );
	
	register_logevent( "OnNewRound", 2, "1=Round_Start" );
	
	RegisterHam( Ham_Killed, "player", "@HamKilled_Post", 1 );
	RegisterHam( Ham_TakeDamage, "player", "@HamTakeDamage_Pre", 0 );
	
	new szWeaponName[ 32 ];
	
	for( new i = CSW_P228; i <= CSW_P90; i++ )
	{
		if( i == CSW_GLOCK )
		continue;
		
		get_weaponname( i, szWeaponName, charsmax( szWeaponName ) );
		RegisterHam( Ham_Weapon_PrimaryAttack, szWeaponName, "@HamPrimaryAttack_Pre" );
	}
}

public plugin_precache( )
OrpheuRegisterHook( OrpheuGetFunction( "InstallGameRules" ), "OnInstallGameRules", OrpheuHookPost );

public plugin_natives( )
{
	register_library( "cs_battleroyale_roundmanager" );

	register_native( "HasGameStarted", "OnNativeHasGameStarted", 1 );
	register_native( "IsLastTeam", "OnNativeIsLastTeam", 1 );
	register_native( "GetTeamAlivePlayers", "OnNativeGetTeamAlivePlayers", 1 );
	register_native( "GetRemainingTeams", "OnNativeGetRemainingTeams", 1 );
}

public OnNativeHasGameStarted( )
{
	return g_bHasGameStarted;
}

public OnNativeIsLastTeam( iTeam )
{
	return IsLastTeam( iTeam );
}

public OnNativeGetTeamAlivePlayers( iTeam )
{
	return GetTeamAlivePlayers( iTeam );
}

public OnNativeGetRemainingTeams( )
{
	return GetRemainingTeams( );
}

public OnInstallGameRules( )
{ 
	g_pGameRules = OrpheuGetReturn( );  
} 

public CHalfLifeMultiplay_RestartRound( ) 
{ 
	HandleFindEntityByClassNameHook = OrpheuRegisterHook( OrpheuGetFunction( "UTIL_FindEntityByClassname" ), "UTIL_FindEntityByClassname", OrpheuHookPre );
}

public OrpheuHookReturn:UTIL_FindEntityByClassname( const pStartEntity, const szClassname[ ] ) 
{ 
	if( equal( szClassname, "hostage_entity" ) ) // first check of the loop is hostage_entity
	{ 
		IsInRightOrder = true 
	} 
	
	else if( equal( szClassname, "player" ) )  
	{ 
		if( IsInRightOrder ) 
		{ 
			OrpheuUnregisterHook( HandleFindEntityByClassNameHook ); 
			IsInRightOrder = false;
			
			return OrpheuSupercede;
		} 
	} 

	else  
	{ 
		IsInRightOrder = false;
	} 
	
	return OrpheuIgnored;
} 

public OrpheuHookReturn:OnFPlayerCanRespawn( pGameRules, id )  
{
	if( g_bHasGameStarted || GetPlayerTeam( id ) == NO_TEAM )
	{
		set_pev( id, pev_flags, FL_DORMANT ) // FL_DORMANT makes player 'invalid' so nothing gets called on him
		OrpheuSetReturn( false );
		
		return OrpheuOverride;  
	}
	return OrpheuIgnored;
}

public client_disconnect( id )
{
	ResetStats( id );

	if( g_bHasGameStarted )
	{
		if( GetAlivePlayers( ) < get_pcvar_num( g_iCvars[ 1 ] ) )
		RestartRound( 3 );
	}
	return PLUGIN_CONTINUE;
}

public @HamTakeDamage_Pre( iVictim, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( ! g_bHasGameStarted )
	return HAM_SUPERCEDE;
	
	if( ! is_user_connected( iAttacker ) )
	return HAM_IGNORED;
	
	if( ( iDamageBits & DMG_BULLET ) || ( iDamageBits & DMG_GENERIC ) )
	{
		g_iPlayerStats[ iAttacker ][ Player_Damage ] += fDamage;
		
		if( get_pdata_int( iVictim, m_LastHitGroup ) == HIT_HEAD )
		{
			g_iPlayerStats[ iAttacker ][ Player_HeadShots ]++;
		}
	}
	return HAM_IGNORED;
}

public @HamPrimaryAttack_Pre( iEnt )
{
	new id;
	id = pev( iEnt, pev_owner );
	
	if( g_bVictoryBlockAttack[ id ] )
	{
		const m_bCanShoot = 876/4;
		
		set_pdata_int( id, m_bCanShoot, false );
		return HAM_SUPERCEDE;
	}
	return HAM_IGNORED;
}

public OnNewRound( )
{
	g_bHasGameStarted = false;

	remove_task( TASK_1 );
	remove_task( TASK_2 );
	
	g_iTime = get_pcvar_num( g_iCvars[ 0 ] );

	if( GetAlivePlayers( ) < get_pcvar_num( g_iCvars[ 1 ] ) )
	{
		set_task( 1.0, "OnTaskFindPlayers", TASK_2, .flags = "b" );
	}
	
	else
	{
		set_task( 1.0, "OnTaskCountDown", TASK_1, .flags = "b" );
	}
}

public OnTaskFindPlayers( )
{
	new szPlayers[ 32 ], iNum, iTempID;
	get_players( szPlayers, iNum, "bch" );
	
	if( iNum > 0 )
	{
		for( new i; i < iNum; i++ )
		{
			iTempID = szPlayers[ i ];
			
			if( GetPlayerTeam( iTempID ) != 0 && ( 1 <= get_user_team( iTempID ) <= 2 ) )
			{
				ExecuteHamB( Ham_CS_RoundRespawn, iTempID );
			}
		}
	}

	if( GetAlivePlayers( ) >= get_pcvar_num( g_iCvars[ 1 ] ) )
	{
		set_task( 1.0, "OnTaskCountDown", TASK_1, .flags = "b" );
		remove_task( TASK_2 );
	}
}

public OnTaskCountDown( )
{	
	if( g_iTime <= 0 )
	{
		g_bHasGameStarted = true;
		
		new szPlayers[ 32 ], iNum;
		static iTempID;
		
		get_players( szPlayers, iNum, "ach" );
		
		for( new i; i < iNum; i++ )
		{
			iTempID = szPlayers[ i ];
			
			if( GetPlayerTeam( iTempID ) == NO_TEAM )
			continue;
			
			ExecuteHamB( Ham_CS_RoundRespawn, iTempID );
		}
		ExecuteForward( g_iFwRoundStart, g_iDummyResult );
		remove_task( TASK_1 );
	}
	
	else
	{
		set_hudmessage( 0, 255, 0, 0.35, 0.35, 0, 0.0, 1.1 )
		ShowSyncHudMsg( 0, g_iSyncHudObject, "%L", LANG_PLAYER, "ROUND_STARTS_IN", g_iTime--, ( g_iTime > 1 ) ? "s" : "" );
	}
} 

public @HamKilled_Post( iVictim, iAttacker, iShouldGib )
{
	if( g_bHasGameStarted )
	{		 
		if( GetTeamAlivePlayers( GetPlayerTeam( iVictim ) ) == 0 )
		{
			BetterLuckNextTime( iVictim );
		}
		
		if( is_user_connected( iAttacker ) )
		{
			if( IsLastTeam( GetPlayerTeam( iAttacker ) ) )
			{
				VictoryRoyale( iAttacker );
			}
			
			if( iVictim != iAttacker )
			{
				g_iPlayerStats[ iAttacker ][ Player_Kills ]++;
			}
		}
	}
	return HAM_IGNORED;
}

VictoryRoyale( id )
{
	new szPlayers[ 32 ], iNum, iTempID;
	get_players( szPlayers, iNum, "ch" );
	
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];
		
		if( GetPlayerTeam( iTempID ) == GetPlayerTeam( id ) )
		{
			if( is_user_alive( iTempID ) )
			{
				g_bVictoryBlockAttack[ iTempID ] = true;
			}
			ShowMotd( iTempID );
		}
	}
	
	client_print( 0, print_center, "%L", LANG_PLAYER, "ROUND_WINNER", GetPlayerTeam( id ) );
	RestartRound( 10 );
}

ShowMotd( id )
{
	new szMotdInfo[ 512 ], szName[ 32 ];
	get_user_name( id, szName, charsmax( szName ) );

	formatex( szMotdInfo, charsmax( szMotdInfo ), "<body bgcolor=^"black^"><font color=^"white^">Player Name: %s <br>Kills: %d <br>Damage: %.1f <br>Headshots: %d<br> <img src=^"https://res.cloudinary.com/teepublic/image/private/s--SOYOT-Oh--/t_Preview/b_rgb:000000,c_limit,f_jpg,h_630,q_90,w_630/v1531417103/production/designs/2883853_0.jpg^" height=^"324^" width=^"324^">", szName, g_iPlayerStats[ id ][ Player_Kills ], g_iPlayerStats[ id ][ Player_Damage ], g_iPlayerStats[ id ][ Player_HeadShots ] );
	show_motd( id, szMotdInfo, "Stats" );
	
	ResetStats( id );
}

RestartRound( iTime )
{
	set_pcvar_num( g_iRestartRound, iTime );
}

BetterLuckNextTime( iPlayer )
{	
	if( GetPlayerPerTeam( ) > 1 )
	{
		new szPlayers[ 32 ], iNum, iTempID;
		get_players( szPlayers, iNum, "bch" );
		
		for( new i; i < iNum; i++ )
		{
			iTempID = szPlayers[ i ];
			
			if( ( GetPlayerTeam( iTempID ) == GetPlayerTeam( iPlayer ) ) )
			{
				client_print( iTempID, print_center, "%L", iTempID, "YOUR_TEAM_PLACED", GetRemainingTeams( ) + 1 );
			}
		}
	}
}

GetRemainingTeams( )
{
	new iRemainingTeams;

	for( new iTeam = 1; iTeam <= GetMaxTeams( ); iTeam++ )
	{
		if( GetTeamAlivePlayers( iTeam ) >= 1 )
		{
			iRemainingTeams++;
		}
	}
	return iRemainingTeams;
}

GetTeamAlivePlayers( iTeam )
{
	new szPlayers[ 32 ], iNum, iTempID, iCount;
	get_players( szPlayers, iNum, "a" );
	
	for( new i; i < iNum; i++ )
	{
		iTempID = szPlayers[ i ];
		
		if( GetPlayerTeam( iTempID ) == iTeam )
		{
			iCount++;
		}
	}
	return iCount;
}

bool:IsLastTeam( iTeam )
{
	new bool:bAnnounceWinner;
	
	for( new i = 1; i <= GetMaxTeams( ); i++ )
	{
		if( iTeam == i )
		continue;
		
		if( GetTeamAlivePlayers( i ) <= 0 )
		{
			bAnnounceWinner = true;
			continue;
		}
		
		else
		{
			bAnnounceWinner = false;
			break;
		}
	}
	
	return bAnnounceWinner;
}

ResetStats( id )
{
	g_iPlayerStats[ id ][ Player_Damage ] = _:0.0;
	g_iPlayerStats[ id ][ Player_HeadShots ] = 0;
	g_iPlayerStats[ id ][ Player_Kills ] = 0;
}

GetAlivePlayers( )
{
	new szPlayers[ 32 ], iNum;
	get_players( szPlayers, iNum, "ach" );
	
	return iNum;
}