/* * * * * * * * * * * * * * * * * * * * * * *
* Returns whether the live game has started.
*
* @return           Has game started or not.
* * * * * * * * * * * * * * * * * * * * * * * */
native HasGameStarted( )


/* * * * * * * * * * * * * * * * * * * * * * *
* Returns whether the specified team is the last one alive.
*
* @param iTeam     Specified team.
*
* @return          True on success, false otherwise.
* * * * * * * * * * * * * * * * * * * * * * * */
native IsLastTeam( iTeam )


/* * * * * * * * * * * * * * * * * * * * * * *
* Returns number of alive players in a specified team.
*
* @param iTeam     Specified team.
*
* @return          Number of alive players.
* * * * * * * * * * * * * * * * * * * * * * * */
native GetTeamAlivePlayers( iTeam )


/* * * * * * * * * * * * * * * * * * * * * * *
* Returns number of remaining teams (alive).
*
* @return          Number of teams.
* * * * * * * * * * * * * * * * * * * * * * * */
native GetRemainingTeams( )

/* * * * * * * * * * * * * * * * * * * * * * *
* Forward called when Round Starts.
* * * * * * * * * * * * * * * * * * * * * * * */

forward RoundStarted( )